import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class Avatar extends StatelessWidget {
  String avtarUrl = '';
  double width = 0;
  double height = 0;
  double radius = 0;
  Avatar({avtarUrl, width, height, radius}) {
    this.avtarUrl = avtarUrl;
    this.width = width.toDouble();
    this.height = height.toDouble();
    this.radius = radius.toDouble();
  }
  @override
  Widget build(BuildContext context) {
    return PhysicalModel(
      color: Colors.transparent,
      borderRadius: BorderRadius.circular(radius),
      clipBehavior: Clip.antiAlias,
      child: Container(
        width: width,
        height: height,
        child: avtarUrl.indexOf('http') > -1
            ? avtarUrl == 'https://picsum.photos/id/745/200/200'
                ? Image(
                    image: AssetImage('images/logo.png'),
                    width: width,
                    height: height,
                  )
                : Image.network(
                    avtarUrl,
                    width: width,
                    height: height,
                  )
            : Image(
                image: AssetImage(avtarUrl),
                width: width,
                height: height,
              ),
      ),
    );
  }
}
