import 'dart:async';

import 'package:flutter/material.dart';
import 'package:tencent_im_sdk_plugin_example/common/colors.dart';
import 'package:webview_flutter/webview_flutter.dart';

class BuyWebview extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => BuyWebviewState();
}

class BuyWebviewState extends State<BuyWebview> {
  final Completer<WebViewController> _controller =
      Completer<WebViewController>();
  JavascriptChannel _toasterJavascriptChannel(BuildContext context) {
    return JavascriptChannel(
        name: 'Toaster',
        onMessageReceived: (JavascriptMessage message) {
          // ignore: deprecated_member_use
          Scaffold.of(context).showSnackBar(
            SnackBar(content: Text(message.message)),
          );
        });
  }

  @override
  Widget build(Object context) {
    return Scaffold(
      appBar: AppBar(
        title: Text('购买'),
        backgroundColor: CommonColors.getThemeColor(),
      ),
      body: Builder(builder: (BuildContext context) {
        return WebView(
          initialUrl: 'https://buy.cloud.tencent.com/avc',
          javascriptMode: JavascriptMode.unrestricted,
          onWebViewCreated: (WebViewController webViewController) {
            _controller.complete(webViewController);
          },
          javascriptChannels: <JavascriptChannel>[
            _toasterJavascriptChannel(context),
          ].toSet(),
          navigationDelegate: (NavigationRequest request) {
            print('allowing navigation to $request');
            return NavigationDecision.navigate;
          },
          onPageStarted: (String url) {
            print('Page started loading: $url');
          },
          onPageFinished: (String url) {
            print('Page finished loading: $url');
          },
          gestureNavigationEnabled: true,
        );
      }),
    );
  }
}
