import 'package:flutter/material.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_group_info_result.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_group_member_info_result.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_user_full_info.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_value_callback.dart';
import 'package:tencent_im_sdk_plugin/tencent_im_sdk_plugin.dart';
import 'package:tencent_im_sdk_plugin_example/common/colors.dart';

class ConversationInfo extends StatefulWidget {
  ConversationInfo(this.id, this.type);
  final String id;
  final int type;
  @override
  State<StatefulWidget> createState() {
    return ConversationInfoState();
  }
}

class ConversationInfoState extends State<ConversationInfo> {
  void initState() {
    this.id = widget.id;
    this.type = widget.type;
    print("当前会话id ${this.id}");
    getDetail();
    super.initState();
  }

  String id;
  int type;
  // 获取用户或者群的详细资料
  getDetail() async {
    if (type == 1) {
      V2TimValueCallback<List<V2TimUserFullInfo>> res =
          await tencent_im_sdk_plugin.v2TIMManager
              .getUsersInfo(userIDList: [id]);
      print("当前用户详情${res.data[0].toJson()}");
    }
    if (type == 2) {
      V2TimValueCallback<List<V2TimGroupInfoResult>> res =
          await tencent_im_sdk_plugin.v2TIMManager
              .getGroupManager()
              .getGroupsInfo(groupIDList: [id]);
      print("当前用户详情${res.data[0].groupInfo.toJson()}");
      String groupID = res.data[0].groupInfo.groupID;
      V2TimValueCallback<V2TimGroupMemberInfoResult> list =
          await tencent_im_sdk_plugin.v2TIMManager
              .getGroupManager()
              .getGroupMemberList(groupID: groupID, filter: 0x00, nextSeq: 0);
      print(list.data.memberInfoList.length);
      print(list.data.memberInfoList[0].toJson());
    }
  }

  @override
  Widget build(Object context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: CommonColors.getThemeColor(),
        title: Text("详细资料"),
      ),
      body: Column(
        children: [],
      ),
    );
  }
}
