import 'dart:ui';
import 'package:provider/provider.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_callback.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_friend_application.dart';

import 'package:tencent_im_sdk_plugin/models/v2_tim_friend_info.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_message.dart';
import 'package:tencent_im_sdk_plugin/tencent_im_sdk_plugin.dart';
import 'package:flutter/material.dart';
import 'package:dio/dio.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_value_callback.dart';

import 'package:tencent_im_sdk_plugin/models/v2_tim_event_callback.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_user_full_info.dart';
import 'package:tencent_im_sdk_plugin_example/common/colors.dart';

import 'package:tencent_im_sdk_plugin_example/pages/home/home.dart';
import 'package:tencent_im_sdk_plugin_example/provider/conversion.dart';
import 'package:tencent_im_sdk_plugin/models/v2_tim_conversation.dart';
import 'package:tencent_im_sdk_plugin_example/provider/currentMessageList.dart';
import 'package:tencent_im_sdk_plugin_example/provider/friend.dart';
import 'package:tencent_im_sdk_plugin_example/provider/friendApplication.dart';
import 'package:tencent_im_sdk_plugin_example/provider/user.dart';
import 'package:toast/toast.dart';

var timLogo = AssetImage("images/logo.png");

class LoginPage extends StatefulWidget {
  @override
  _LoginPageState createState() => _LoginPageState();
}

class _LoginPageState extends State<LoginPage> {
  bool isinit = false;
  void initState() {
    super.initState();
    test();
    islogin();
  }

  islogin() async {
    Future<SharedPreferences> _prefs = SharedPreferences.getInstance();
    SharedPreferences prefs = await _prefs;
    String token = prefs.getString("token");
    String sessionId = prefs.getString("sessionId");
    String phone = prefs.getString("phone");
    String code = prefs.getString("code");
    print("token${token}");
    print("sessionId${sessionId}");
    print("phone${phone}");
    print("code${code}");
    if (token != null && sessionId != null && phone != null && code != null) {
      Dio dio = new Dio();
      Response response = await dio.get(
        "https://service-c2zjvuxa-1252463788.gz.apigw.tencentcs.com/release/demoSms",
        queryParameters: {
          "phone": "86${phone}",
          "method": "login",
          "sessionId": sessionId,
          "token": token,
          "code": code
        },
      );
      print(response);
      if (response.data['errorCode'] == 0) {
        //登录成功
        String userId = response.data['data']['userId'];
        String userSig = response.data['data']['userSig'];
        String avatar = response.data['data']['avatar'];

        V2TimCallback data = await tencent_im_sdk_plugin.v2TIMManager.login(
          userID: userId,
          userSig: userSig,
        );

        if (data.code != 0) {
          print('登录失败');
          setState(() {
            isinit = true;
          });
          return;
        } else {
          print("登录成功");
        }

        V2TimValueCallback<List<V2TimUserFullInfo>> infos =
            await tencent_im_sdk_plugin.v2TIMManager
                .getUsersInfo(userIDList: [userId]);
        if (infos.code == 0) {
          if (infos.data[0].nickName == null ||
              infos.data[0].faceUrl == null ||
              infos.data[0].nickName == '' ||
              infos.data[0].faceUrl == '') {
            await tencent_im_sdk_plugin.v2TIMManager
                .setSelfInfo(nickName: userId, faceUrl: avatar);
          }
          Provider.of<UserModel>(context, listen: false).setInfo(infos.data[0]);
        } else {}
        try {
          Navigator.of(context).push(
            new MaterialPageRoute(
              builder: (context) {
                return HomePage();
              },
            ),
          );
        } catch (err) {
          print(err);
        }
      } else {}
    } else {}
    setState(() {
      isinit = true;
    });
  }

  listener(V2TimEventCallback data) async {
    print("init sdk listener emit");
    print(data.type);
    if (data.type == 'onSelfInfoUpdated') {
      //自己信息更新，从新获取自己的信息；
      V2TimValueCallback<String> usercallback =
          await tencent_im_sdk_plugin.v2TIMManager.getLoginUser();
      V2TimValueCallback<List<V2TimUserFullInfo>> infos =
          await tencent_im_sdk_plugin.v2TIMManager
              .getUsersInfo(userIDList: [usercallback.data]);
      if (infos.code == 0) {
        Provider.of<UserModel>(context, listen: false).setInfo(infos.data[0]);
      }
    }
    if (data.type == 'onKickedOffline') {
      // 被踢下线
      // 清除本地缓存，回到登录页TODO
      // Navigator.of(context).push(route)
    }
    // print(data.toJson());
  }

  groupListener(data) {
    print("groupListener emit");
    print(data.type);
    if (data.type == 'onReceiveJoinApplication') {
      //新加群申请

    }
  }

  advancedMsgListener(V2TimEventCallback data) {
    print("advancedMsgListener emit");
    print(data.type);
    if (data.type == 'onRecvNewMessage') {
      print('收到了新消息');
      try {
        List<V2TimMessage> messageList = new List();
        V2TimMessage message = data.data;
        print(message.toJson());
        messageList.add(message);
        print("c2c_${message.sender}");
        String key;
        if (message.groupID == null) {
          key = "c2c_${message.sender}";
        } else {
          key = "group_${message.groupID}";
        }
        print(context);
        Provider.of<CurrentMessageListModel>(context, listen: false)
            .addMessage(key, messageList);
      } catch (err) {
        print(err);
      }
    }
//

    // print(data.toJson());
  }

  friendListener(V2TimEventCallback data) {
    print("friendListener emit");
    String type = data.type;
    if (type == 'onFriendListAdded') {
      //好友加成功了，
      List<V2TimFriendInfo> list = data.data;
      List<V2TimFriendInfo> oldList =
          Provider.of<FriendListModel>(context, listen: false).friendList;
      if (oldList == null || oldList.length == 0) {
        oldList = [];
      }
      oldList.addAll(list);
      Provider.of<FriendListModel>(context, listen: false)
          .setFriendList(oldList);
    }
    if (type == 'onFriendApplicationListAdded') {
      // 收到加好友申请
      List<V2TimFriendApplication> list = data.data;
      Provider.of<FriendApplicationModel>(context, listen: false)
          .setFriendApplicationResult(list);
    }
    print(data.type);
  }

  Map<String, V2TimConversation> conversationlistToMap(
      List<V2TimConversation> list) {
    Map<int, V2TimConversation> convsersationMap = list.asMap();
    Map<String, V2TimConversation> newConversation = new Map();
    convsersationMap.forEach((key, value) {
      newConversation[value.conversationID] = value;
    });
    return newConversation;
  }

  conversationListener(V2TimEventCallback data) {
    String type = data.type;

    if (type == 'onNewConversation' || type == 'onConversationChanged') {
      print("${type} emit");
      try {
        List<V2TimConversation> renderList =
            Provider.of<ConversionModel>(context, listen: false).conversionList;

        List<V2TimConversation> list = data.data;

        Map<String, V2TimConversation> renderConversationMap =
            conversationlistToMap(renderList);
        Map<String, V2TimConversation> updateConversationMap =
            conversationlistToMap(list);
        updateConversationMap.forEach((key, value) {
          renderConversationMap[key] = value;
        });
        List<V2TimConversation> updateList =
            renderConversationMap.values.toList();
        Provider.of<ConversionModel>(context, listen: false)
            .setConversionList(updateList);
        //如果当前会话在使用中，也更新一下

      } catch (e) {}
    } else {
      print("${type} emit but no nerver use");
    }
  }

  signalingListener(data) {
    print("signalingListener emit");
    // print(data);
  }

  simpleMsgListener(V2TimEventCallback data) {
    //这里区分消息
    print("simpleMsgListener emit");

    print(data.type);
  }

  test() async {
    await tencent_im_sdk_plugin.v2TIMManager.initSDK(
      // sdkAppID: 1400425583,
      sdkAppID: 1400187352,
      loglevel: 0,
      listener: listener,
    );

    //简单监听
    tencent_im_sdk_plugin.v2TIMManager.addSimpleMsgListener(
      listener: simpleMsgListener,
    );

    //群组监听
    tencent_im_sdk_plugin.v2TIMManager.setGroupListener(
      listener: groupListener,
    );
    //高级消息监听
    tencent_im_sdk_plugin.v2TIMManager
        .getMessageManager()
        .addAdvancedMsgListener(
          advancedMsgListener,
        );
    //关系链监听
    tencent_im_sdk_plugin.v2TIMManager.getFriendshipManager().setFriendListener(
          listener: friendListener,
        );
    //会话监听
    tencent_im_sdk_plugin.v2TIMManager
        .getConversationManager()
        .setConversationListener(
          conversationListener,
        );
    tencent_im_sdk_plugin.v2TIMManager
        .getSignalingManager()
        .addSignalingListener(
          signalingListener,
        );
    print("初始化完成了");
  }

  @override
  Widget build(BuildContext context) {
    return (!isinit) ? new WaitHomeWidget() : new HomeWidget();
  }
}

class WaitHomeWidget extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => WaitHomeWidgetState();
}

class WaitHomeWidgetState extends State<WaitHomeWidget> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(),
    );
  }
}

class HomeWidget extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => HomeWidgetState();
}

class HomeWidgetState extends State<HomeWidget> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: new AppLayout(),
    );
  }
}

class AppLayout extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        AppLogo(),
        Expanded(
          child: LoginForm(),
        )
      ],
    );
  }
}

class AppLogo extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Container(
      height: 192.0,
      color: CommonColors.getThemeColor(),
      alignment: Alignment.topLeft,
      padding: EdgeInsets.only(
        top: 108.0,
      ),
      child: Row(
        children: <Widget>[
          Container(
            height: 90,
            width: 90,
            child: Image(
              image: timLogo,
              width: 90.0,
              height: 90.0,
            ),
          ),
          Container(
            height: 90.0,
            padding: EdgeInsets.only(
              top: 10,
            ),
            child: Column(
              children: <Widget>[
                Text(
                  '登录·即时通信',
                  style: TextStyle(
                    color: Color.fromARGB(255, 255, 255, 255),
                    fontSize: 28,
                  ),
                ),
                Text(
                  '体验群组聊天，音视频对话等M功能',
                  style: TextStyle(
                    color: Color.fromARGB(255, 255, 255, 255),
                    fontSize: 12,
                  ),
                ),
              ],
              crossAxisAlignment: CrossAxisAlignment.start,
            ),
          )
        ],
      ),
    );
  }
}

class LoginForm extends StatefulWidget {
  _LoginFormState createState() => _LoginFormState();
}

class _LoginFormState extends State<LoginForm> {
  void initState() {
    super.initState();
  }

  bool isGeted = false;
  String tel = '';
  String pwd = '';
  int timer = 60;
  String token = '';
  String sessionId = '';
  TextEditingController userSigEtController = TextEditingController();
  void getHttp() async {
    try {
      Response response = await Dio().get(
        "https://service-qr8jjnpm-1256635546.gz.apigw.tencentcs.com/release/getUserSig?userId=xingchenhe",
      );
      print(response);
    } catch (e) {
      print(e);
    }
  }

  timeDown() {
    new Future.delayed(const Duration(milliseconds: 1000), () {
      if (timer == 0) {
        setState(() {
          timer = 60;
          isGeted = false;
        });
        return;
      }
      setState(() {
        timer = --timer;
      });
      timeDown();
    });
  }

  void getLoginCode(context) async {
    if (tel.length == 0) {
      Toast.show(
        "请输入正确的手机号码",
        context,
        duration: Toast.LENGTH_SHORT,
        gravity: Toast.TOP,
      );
    } else {
      Dio dio = new Dio();
      Response response = await dio.get(
        "https://service-c2zjvuxa-1252463788.gz.apigw.tencentcs.com/release/demoSms",
        queryParameters: {
          "phone": "86${this.tel}",
          "method": "getSms",
        },
      );
      print(response);
      try {
        if (response.data['errorCode'] == 0) {
          print(response.data['data']['sessionId']);
        }
        setState(() {
          isGeted = true;
          sessionId = response.data['data']['sessionId'];
        });
        timeDown();
      } catch (err) {
        print(err);
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.fromLTRB(16, 40, 16, 0),
      child: Form(
        child: Column(
          children: [
            TextField(
              autofocus: false,
              decoration: InputDecoration(
                labelText: "手机号",
                hintText: "请输入手机号码",
                icon: Icon(Icons.phone_android),
              ),
              keyboardType: TextInputType.number,
              onChanged: (v) {
                setState(() {
                  tel = v;
                });
              },
            ),
            Row(
              children: [
                Expanded(
                  child: TextField(
                    controller: userSigEtController,
                    decoration: InputDecoration(
                      labelText: "验证码",
                      hintText: "请输入验证码",
                      icon: Icon(Icons.lock),
                    ),
                    keyboardType: TextInputType.number,
                    //校验密码
                    onChanged: (v) {
                      setState(() {
                        pwd = v;
                      });
                    },
                  ),
                ),
                Container(
                  width: 120,
                  child: RaisedButton(
                    child: isGeted ? Text(timer.toString()) : Text("获取验证码"),
                    color: CommonColors.getThemeColor(),
                    textColor: Colors.white,
                    onPressed: isGeted
                        ? null
                        : () {
                            //获取验证码
                            getLoginCode(context);
                          },
                  ),
                )
              ],
            ),
            Container(
              margin: EdgeInsets.only(
                top: 28,
              ),
              child: Row(
                children: [
                  Expanded(
                    child: RaisedButton(
                      padding: EdgeInsets.only(
                        top: 15,
                        bottom: 15,
                      ),
                      child: Text("登录"),
                      color: CommonColors.getThemeColor(),
                      textColor: Colors.white,
                      onPressed: () async {
                        if (tel == '') {
                          return;
                        }
                        if (pwd == '') {
                          return;
                        }
                        // 获取userSig
                        Dio dio = new Dio();
                        Response response = await dio.get(
                          "https://service-c2zjvuxa-1252463788.gz.apigw.tencentcs.com/release/demoSms",
                          queryParameters: {
                            "phone": "86${this.tel}",
                            "method": "login",
                            "code": pwd,
                            "sessionId": sessionId,
                          },
                        );

                        String userId = response.data['data']['userId'];
                        String userSig = response.data['data']['userSig'];
                        String token = response.data['data']['token'];
                        String avatar = response.data['data']['avatar'];
                        print(response);
                        if (response.data['errorCode'] != 0) {
                          Toast.show(
                            response.data['errorMessage'],
                            context,
                            duration: Toast.LENGTH_SHORT,
                            gravity: Toast.TOP,
                          );
                          return;
                        } else {
                          setState(() {
                            token = token;
                          });
                        }
                        var data =
                            await tencent_im_sdk_plugin.v2TIMManager.login(
                          userID: userId,
                          userSig: userSig,
                        );

                        if (data.code != 0) {
                          print('登录失败');
                          return;
                        }
                        Future<SharedPreferences> _prefs =
                            SharedPreferences.getInstance();
                        SharedPreferences prefs = await _prefs;
                        prefs.setString("sessionId", sessionId);
                        prefs.setString("token", token);
                        prefs.setString("phone", tel);
                        prefs.setString("code", pwd);
                        V2TimValueCallback<List<V2TimUserFullInfo>> infos =
                            await tencent_im_sdk_plugin.v2TIMManager
                                .getUsersInfo(userIDList: [userId]);

                        if (infos.code == 0) {
                          if (infos.data[0].nickName == null ||
                              infos.data[0].faceUrl == null ||
                              infos.data[0].nickName == '' ||
                              infos.data[0].faceUrl == '') {
                            await tencent_im_sdk_plugin.v2TIMManager
                                .setSelfInfo(nickName: userId, faceUrl: avatar);
                          }
                          Provider.of<UserModel>(context, listen: false)
                              .setInfo(infos.data[0]);
                        }
                        Navigator.pushReplacement(
                          context,
                          new MaterialPageRoute(
                            builder: (context) => HomePage(),
                          ),
                        );
                      },
                    ),
                  )
                ],
              ),
            ),
            Expanded(
              child: Container(),
            )
          ],
        ),
      ),
    );
  }
}
